﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[System.Serializable]
public class Event {

	public string Id;
	public bool RootEvent;
	public string Title;
	public string Description;

	public string Screen;
	public string sfx;

	public string tag;

	public List<EventAction> ActionList = new List<EventAction>();

	public override string ToString ()
	{
		return string.Format (
		"[Event id:"+Id+", Title:"+Title+"]");
	}
}
	

[System.Serializable]
public class EventAction {
	public string Id;
	public string Title;


	public List<EventCause> CauseList = new List<EventCause>();
	public List<EventEffect> EffectList = new List<EventEffect>();
}


[System.Serializable]
public class EventCause {
	public string Id;
	public List<EventCauseArg> ArgumentList = new List<EventCauseArg>();


	public string[] GetArgArray()
	{
		int argCount = ArgumentList.Count;
		string []args = null;

			if(argCount > 0){
				args = new string[argCount];
				for(int idx=0; idx < argCount; idx++)
				{
					args[idx] = ArgumentList[idx].Value;
				}
			}
		return args;
	}
}

[System.Serializable]
public class EventCauseArg{
	public string Name;
	public string Value;
}


[System.Serializable]
public class EventEffect {
	public string Id;
	public List<EventEffectArg> ArgumentList = new List<EventEffectArg>();

	public string[] GetArgArray()
	{
		int argCount = ArgumentList.Count;
		string []args = null;

			if(argCount > 0){
				args = new string[argCount];
				for(int idx=0; idx < argCount; idx++)
				{
					args[idx] = ArgumentList[idx].Value;
				}
			}
		return args;
	}
}

[System.Serializable]
public class EventEffectArg {
	public string Name;
	public string Value;
}