﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public static class EventActionHandler {



	public static class CauseCall {

		public static void hide_valuables(){
			Debug.Log("EventActionHandler.CauseCall.hide_valuables called!");
		}

		/// <summary>
		/// Sets player's money to zero.
		/// </summary>
		public static void remove_player_money(){
			AccessHelper.GameStates.GetPlayerState().Money = 0;
		}

		public static void decrease_health(string amountStr){
				Debug.Log("CauseCall:decrease_health"+amountStr);
				float amount = float.Parse(amountStr);
				float newHealth = AccessHelper.GameStates.GetPlayerState().Health-amount;
				AccessHelper.GameStates.GetPlayerState().Health = newHealth;
		}
		
		public static void increase_health(string amountStr){
				Debug.Log("CauseCall:increase_health"+amountStr);
				float amount = float.Parse(amountStr);
				float newHealth = AccessHelper.GameStates.GetPlayerState().Health+amount;
				AccessHelper.GameStates.GetPlayerState().Health = newHealth;
		}
		  

		public static void decrease_happiness(string amountStr){
				Debug.Log("CauseCall:degrease_happiness"+amountStr);
				float amount = float.Parse(amountStr);
				float newHappiness = AccessHelper.GameStates.GetPlayerState().Happiness-amount;
				AccessHelper.GameStates.GetPlayerState().Happiness = newHappiness;
		}


		public static void increase_happiness(string amountStr){
				Debug.Log("CauseCall:increase_happiness"+amountStr);
				float amount = float.Parse(amountStr);
				float newHappiness = AccessHelper.GameStates.GetPlayerState().Happiness+amount;
				AccessHelper.GameStates.GetPlayerState().Happiness = newHappiness;
		}

		public static void increase_energy(string amountStr){
				Debug.Log("CauseCall:increase_energy"+amountStr);
				float amount = float.Parse(amountStr);
				float newEnergy = AccessHelper.GameStates.GetPlayerState().Energy+amount;
				AccessHelper.GameStates.GetPlayerState().Energy = newEnergy;
		}

		public static void decrease_energy(string amountStr){
				Debug.Log("CauseCall:decrease_energy"+amountStr);
				float amount = float.Parse(amountStr);
				float newEnergy = AccessHelper.GameStates.GetPlayerState().Energy-amount;
				AccessHelper.GameStates.GetPlayerState().Energy = newEnergy;
		}

		
		public static void increase_hunger(string amountStr){
				Debug.Log("CauseCall:increase_hunger"+amountStr);
				float amount = float.Parse(amountStr);
				float newHunger = AccessHelper.GameStates.GetPlayerState().Hunger+amount;
				AccessHelper.GameStates.GetPlayerState().Hunger = newHunger;
		}

		public static void decrease_hunger(string amountStr){
				Debug.Log("CauseCall:decrease_hunger"+amountStr);
				float amount = float.Parse(amountStr);
				float newHunger = AccessHelper.GameStates.GetPlayerState().Hunger-amount;
				AccessHelper.GameStates.GetPlayerState().Hunger = newHunger;
		}

				
		public static void increase_money(string amountStr){
				Debug.Log("CauseCall:increase_money"+amountStr);
				float amount = float.Parse(amountStr);
				float newMoney = AccessHelper.GameStates.GetPlayerState().Money+amount;
				AccessHelper.GameStates.GetPlayerState().Money = newMoney;
		}

		public static void decrease_money(string amountStr){
				Debug.Log("CauseCall:decrease_money"+amountStr);
				float amount = float.Parse(amountStr);
				float newMoney = AccessHelper.GameStates.GetPlayerState().Money-amount;
				AccessHelper.GameStates.GetPlayerState().Money = newMoney;
		}

		public static void log_call(string test1, string test2){
			Debug.Log("log_call was called, with test1:"+test1+", and test2:"+test2);
		}


	}

	public static class EffectCall {

		/// <summary>
		/// When called, the EventViewController is closed.
		/// </summary>
		public static void event_finish(){
			//AccessHelper.GameGUI.GetEventViewController().ShowView(false);
			AccessHelper.GameLogic.GetGameScript().CurrentState = GameScript.GameState.TIME_ADVANCE;
		}

		public static void hide_event_view(){
			AccessHelper.GameGUI.GetEventViewController().ShowView(false);
		}

		public static void jump_to_event(string event_id){
			AccessHelper.GameGUI.GetEventViewController().StartEvent(event_id);
		}

		public static void jump_to_random_n2(string eventId1, string eventId2){
				Debug.Log("jump_to_random_n2 called id1:"+eventId1+", id2:"+eventId2);
				if( Random.value > 0.5){
					AccessHelper.GameGUI.GetEventViewController().StartEvent(eventId1);
				}
				else{	
					AccessHelper.GameGUI.GetEventViewController().StartEvent(eventId2);
				}
		}


		public static void random_tagged_event(string tag) {
			Debug.Log("RANDOM TAGGED EVENT");
			string id = AccessHelper.Database.GetEventDB().GetRandomEvent(tag).Id;
			AccessHelper.GameGUI.GetEventViewController().StartEvent(id);
		}





	}



}
