﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.Xml;

public class EventDB : MonoBehaviour {

	public EventData eventData = null;
	private Dictionary<string, Event> eventDict = new Dictionary<string, Event>();

	private List<Event> rootEvents = new List<Event>();

	// Use this for initialization
	public void InitDatabase () {


		if(!eventData){
			Debug.LogWarning("EventDB is missing public reference to the EventData ScriptableObject.");
		}

		// Create Dictionary
		foreach(Event _event in eventData.EventList){
			eventDict.Add(_event.Id, _event);
			Debug.Log("Adding event:"+_event.Id+", rootEvent:"+_event.RootEvent);
			if(_event.RootEvent){
				rootEvents.Add(_event);
			}
		}

	}

	public Event GetEvent(string eventId){
		Event temp = null;
		if(eventDict.TryGetValue(eventId, out temp)){
			return temp;
		}
		Debug.Log("Failed to GetEvent, unknown id:"+eventId);
		return null;
	}

	// Returns random event
	public Event GetRandomRootEvent(string tag){

		// TODO: Use linq
		List<Event> resultList = new List<Event>();

		foreach(Event _event in rootEvents){
			Debug.Log("Resulted root event:"+_event.ToString());
			if(tag == _event.tag){
				resultList.Add(_event);
			}
		}

       	return resultList[Random.Range(0, resultList.Count)];
	}



	public Event GetRandomRootEvent(){
		return rootEvents[Random.Range(0,rootEvents.Count)];
	}

	// Returns random event
	public Event GetRandomEvent(string tag){

		// TODO: Use linq
		List<Event> resultList = new List<Event>();

		foreach(Event _event in eventData.EventList){
			Debug.Log("Resulted root event:"+_event.ToString());
			if(tag == _event.tag){
				resultList.Add(_event);
			}
		}

       	return resultList[Random.Range(0, resultList.Count)];
	}

	public Event GetRandomRootEventExcluding(List<string> tags) {
		List<Event> resultList = new List<Event>();

		foreach(Event _event in rootEvents){
			Debug.Log("Resulted root event:"+_event.ToString());
			if(!tags.Contains(_event.tag)){
				resultList.Add(_event);
			}
		}

       	return resultList[Random.Range(0, resultList.Count)];
	}

	public void Awake(){
		InitDatabase();
	}

}
