﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.Xml;
using System;

public class EventData : ScriptableObject {

	public List<Event> EventList = new List<Event>();


	public void PopulateEventList(string xmlData){


		XmlDocument xmlDocument = new XmlDocument();


		xmlDocument.LoadXml(xmlData);

		XmlElement root;
		root = xmlDocument.DocumentElement;

		foreach(XmlNode eventNode in root.ChildNodes){

			Event tempEvent = new Event();
			Debug.Log("Event id:"+eventNode.Attributes["id"].Value.ToString());
			tempEvent.Id = eventNode.Attributes["id"].Value.ToString();
			tempEvent.RootEvent = Convert.ToBoolean(eventNode.Attributes["root"].Value.ToString());

			if (eventNode.Attributes["tag"] != null){
				Debug.Log("The Event node Tag exist for id:"+tempEvent.Id);
				tempEvent.tag = eventNode.Attributes["tag"].Value.ToString();
			}

			if (eventNode.Attributes["sfx"] != null){
				tempEvent.sfx = eventNode.Attributes["sfx"].Value.ToString();
			}

			tempEvent.Title = eventNode.SelectSingleNode("title").InnerText.ToString();
			tempEvent.Screen = eventNode.SelectSingleNode("screen").InnerText.ToString();
			tempEvent.Description = eventNode.SelectSingleNode("description").InnerText.ToString();

	
			//tempEvent.MinMinutes = Convert.ToInt32(eventNode.SelectSingleNode("

			XmlNode actionNodes = eventNode.SelectSingleNode("actions");
			foreach(XmlNode actionNode in actionNodes.ChildNodes){
				EventAction tempAction = createAction(actionNode);
				tempEvent.ActionList.Add(tempAction);

			}

			EventList.Add(tempEvent);
		}

	}

	 EventAction createAction(XmlNode actionNode){
	 	EventAction tempAction = new EventAction();

		tempAction.Id = actionNode.Attributes["id"].Value.ToString();
		tempAction.Title = actionNode.SelectSingleNode("title").InnerText.ToString();

		Debug.Log("---->Creating action:"+actionNode.Attributes["id"].Value.ToString());
		createCauses(actionNode.SelectSingleNode("causes"), tempAction);
		createEffects(actionNode.SelectSingleNode("effects"), tempAction);

		return tempAction;

	}

	void createCauses(XmlNode causesNode, EventAction action){
		foreach(XmlNode causeNode in causesNode.ChildNodes){
			EventCause tempCause = new EventCause();
			tempCause.Id = causeNode.Attributes["id"].Value.ToString();

			foreach(XmlNode argNode in causeNode.ChildNodes){
				EventCauseArg causeArg = new EventCauseArg();
				causeArg.Name = argNode.Attributes["name"].Value.ToString();
				causeArg.Value = argNode.Attributes["value"].Value.ToString();
				tempCause.ArgumentList.Add(causeArg);
			}
			action.CauseList.Add(tempCause);
		}
	}


	void createEffects(XmlNode effectsNode, EventAction action){

		foreach(XmlNode effectNode in effectsNode.ChildNodes){
			EventEffect tempEffect = new EventEffect();
			Debug.Log("Code:"+effectNode.Attributes.ToString());
			tempEffect.Id = effectNode.Attributes["id"].Value.ToString();

			foreach(XmlNode argNode in effectNode.ChildNodes){
				EventEffectArg effectArg = new EventEffectArg();
				effectArg.Name = argNode.Attributes["name"].Value.ToString();
				effectArg.Value = argNode.Attributes["value"].Value.ToString();
				tempEffect.ArgumentList.Add(effectArg);
			}
			action.EffectList.Add(tempEffect);
		}
	}
}
