﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class PlayerState : MonoBehaviour {

	public RectTransform HealthBar;
	public RectTransform HungerBar;
	public RectTransform EnergyBar;
	public RectTransform HappinessBar;

	public float m_Health = 100;
	public float Health {
		get { return m_Health; }
		set { m_Health = Mathf.Clamp(value, 0, 100.0f);}
	}


	public float m_Happiness = 100;
	public float Happiness {
		get { return m_Happiness; }
		set { m_Happiness = Mathf.Clamp(value, 0, 100.0f);}
	}



	public float m_Hunger = 100;
	public float Hunger {
		get { return m_Hunger; }
		set{ m_Hunger = Mathf.Clamp(value, 0, 100.0f); }
	}


	public float m_Energy = 100;
	public float Energy {
		get { return m_Energy; }
		set{ m_Energy = Mathf.Clamp(value, 0, 100.0f); }
	}
	

	public float m_Money = 100;
	public float Money {
		get { return m_Money; }
		set{ m_Money = Mathf.Clamp(value, 0, 100.0f); }
	}


	void Update() {
		if (Health == 0 || Happiness == 0 || Hunger == 0 || Energy == 0 || Money == 0) {
			AccessHelper.GameLogic.GetGameScript().CurrentState = GameScript.GameState.LOSE;
		}

		HealthBar.sizeDelta = new Vector2(Health / 100 * 50, 20);
		HungerBar.sizeDelta = new Vector2(Hunger / 100 * 50, 20);
		EnergyBar.sizeDelta = new Vector2(Energy / 100 * 50, 20);
		HappinessBar.sizeDelta = new Vector2(Happiness / 100 * 50, 20);
	}

	public void Reset() {
		Happiness = 100;
		Hunger = 100;
		Energy = 100;
		Health = 100;
	}
}
