﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BaseView : MonoBehaviour {

	public bool showView = false;
	public bool visibleFromStart = false;

	// Use this for initialization
	void Start () {
		//Debug.Log("BaseView::Start() called->visibleFromStart"+visibleFromStart.ToString());
		ShowView(visibleFromStart);
	}


	public void ShowViewRestricted(bool show, List<string> restrictedGOList){
		foreach(Transform child in transform){
			//Debug.Log("BaseView::ShowView->setting:"+child.name);
			if(!restrictedGOList.Contains(child.name)){
				child.gameObject.SetActive(show);
			}
		}
	}


	public void ShowView(bool show){
		foreach(Transform child in transform){
			//Debug.Log("BaseView::ShowView->setting:"+child.name);
			child.gameObject.SetActive(show);
		}
	}

	public void ToggleShowView(){
		showView = !showView;
		Debug.Log("Toggle:"+showView.ToString());
		ShowView(showView);
	}


}
