﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GameScript : MonoBehaviour
{
    public VacationTime Clock;
    public enum GameState {
        START_SCREEN,
        TIME_ADVANCE,
        EVENT,
        LOSE,
        WIN
    }

    public float ResultDelay;

    GameState m_State = GameState.START_SCREEN;
    public GameState CurrentState {
        get {
            return m_State;
        }

        set {
            switch (value) {
                case GameState.START_SCREEN:
                    Clock.Running = false;
                    Clock.Reset();
                    AccessHelper.GameGUI.GetTimeAdvanceViewController().Reset();
                    AccessHelper.GameGUI.GetStartViewController().ShowView(true);
                    AccessHelper.GameGUI.GetTimeAdvanceViewController().ShowView(false);
                    AccessHelper.GameGUI.GetWinViewController().ShowView(false);
                    AccessHelper.GameGUI.GetLoseViewController().ShowView(false);
                    break;
                case GameState.TIME_ADVANCE:
                    AccessHelper.GameGUI.GetStartViewController().ShowView(false);
                    AccessHelper.GameGUI.GetEventViewController().ShowView(false);
                    AccessHelper.GameGUI.GetTimeAdvanceViewController().ShowView(true);
                    Clock.Running = true;
                    break;
                case GameState.EVENT:
                    AccessHelper.GameGUI.GetEventViewController().ShowView(true);
                    AccessHelper.GameGUI.GetTimeAdvanceViewController().ShowView(false);
                    Clock.Running = false;
                    break;
                case GameState.WIN:
                    AccessHelper.GameGUI.GetEventViewController().ShowView(false);
                    AccessHelper.GameGUI.GetTimeAdvanceViewController().ShowView(false);
                    AccessHelper.GameGUI.GetWinViewController().ShowView(true);
                // Show end screen
                    break;
                case GameState.LOSE:
                    AccessHelper.GameGUI.GetEventViewController().ShowView(false);
                    AccessHelper.GameGUI.GetTimeAdvanceViewController().ShowView(false);
                    AccessHelper.GameGUI.GetLoseViewController().ShowView(true);
                // SHow lose screen
                    break;
            }

            Debug.Log("GAME STATE CHANGED " + value);
            m_State = value;
        }
    }

    IEnumerator ChangeState(GameState state, float delay) {
        yield return new WaitForSeconds(delay);
        CurrentState = state;
    }

    // Start is called before the first frame update
    void Start()
    {
       StartCoroutine(ChangeState(GameState.START_SCREEN, 0.1f));
        
    }

    // Update is called once per frame
    void Update()
    {
    }

    public void Restart() {
        CurrentState = GameState.START_SCREEN;
        AccessHelper.GameStates.GetPlayerState().Reset();
    }
}
